#ifndef SKELETON_H
#define SKELETON_H

#include <glm/glm.hpp>
#include <map>
#include "RBT.h"

class Skeleton;

class Bone
{
private:
	RigTForm transform_;
	glm::vec3 offset_;
	Bone* parent_;
public:
	Bone(Bone* parent,const glm::vec3& offset,const RigTForm& transform);

	void rotateBy(const glm::mat4& rotation);
	void setRotation(const glm::mat4& rotation);

	glm::mat4 getModelMatrix() const;
	glm::mat4 getBoneMatrix() const;
};

class Skeleton
{
private:
	std::map<int,Bone*> bones_;
public:
	Skeleton();
	~Skeleton();

	Bone* addBone(int name,Bone* parent,const glm::vec3& offset,const RigTForm& transform);
	Bone* getNamedBone(int name);
};

#endif
